-- A simple program to test Gdk drawing routines
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gdk
import Gtk    hiding (main)
import qualified
       Gtk    (main)

exposureHandler    :: DrawingArea -> IO Bool
exposureHandler da  =
  do
    style <- widgetGetStyle da
    state <- widgetGetState da
    gc    <- styleGetFgGC style state
    drawable <- widgetGetWindow da
    drawLine drawable gc 0 0 100 100
    drawRectangle drawable gc True 50 0 100 50 
    drawPolygon drawable gc True 
      [Point 10 35, Point 15 90, Point 55 65, Point 25 55]
    return False

Main.main :: IO ()
main  = do
	  _ <- Gtk.init Nothing

	  window <- windowNew WindowToplevel
	  windowSetTitle window "GTK+ Drawing Area Test"
	  widgetSetUSize window 200 100
	  let winDelHdl = WidgetDeleteEventHandler $ \_ _ -> do
							       Gtk.mainQuit
							       return False
	  signalConnect window winDelHdl
	  containerBorderWidth window 10

          drawArea <- drawingAreaNew
	  let exposureHdl = WidgetExposeEventHandler $ 
			      \da _ -> exposureHandler da
          signalConnect drawArea exposureHdl
          containerAdd window drawArea
          widgetShow drawArea

	  widgetShow window

	  Gtk.main
	  exitWith ExitSuccess
