-- The enhanced & robust infamous `Hello World!' program using the GTK binding
-- for Haskell 
--
--    ghc -o hello3 -fglasgow-exts -i.. -L.. -lgtkHS GtkHelloWorld3.hs\
--      `gtk-config --cflags` `gtk-config --libs`
--

import System (getArgs, ExitCode(ExitSuccess))
import Gtk    (WindowType(..),
               ObjectSignalHandler(..), signalConnect,
	       Button, buttonNewWithLabel,
	       ButtonSignalHandler(..),
	       Container, containerSetBorderWidth, containerAdd,
	       Widget, widgetShow, widgetDestroy,
	       Window, windowNew)
import qualified
       Gtk    (init, main, exit)

hello :: IO ()
hello  = do
	   putStr "Hello World!\n"
	   Gtk.exit ExitSuccess

destroy :: IO ()
destroy  = Gtk.exit ExitSuccess

main :: IO ()
main  = do
	  Gtk.init Nothing

	  window <- windowNew WindowToplevel
	  signalConnect window (ObjectDestroyHandler (const destroy))
	  containerSetBorderWidth window 10

	  button <- buttonNewWithLabel "Hello World!"
	  signalConnect button (ButtonClickedHandler (const hello))
	  let handler = const $ widgetDestroy window
	  signalConnect
	    button $ ButtonClickedHandler handler
	  containerAdd window button
	  widgetShow button

	  widgetShow window

	  Gtk.main
