-- The upgraded enhanced & even more robust infamous `Hello World!' program
-- using the GTK binding for Haskell 
--
--    ghc -o hello5 -fglasgow-exts -i.. -L.. -lgtkHS GtkHelloWorld5.hs\
--      `gtk-config --cflags` `gtk-config --libs`
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk    (WindowType(..),
               ObjectSignalHandler(..), signalConnect,
	       Box, boxPackStart,
	       HBox, hBoxNew,
	       Button, ButtonClass(..), buttonNewWithLabel,
	       ButtonSignalHandler(..),
	       Container, containerBorderWidth, containerAdd,
	       Widget, WidgetClass(..), widgetShow, widgetDestroy,
	       WidgetSignalHandler(..), 
	       Window, windowNew, windowSetTitle,
	       mainQuit)
import qualified
       Gtk    (init, main)

hello     :: String -> IO ()
hello str  = putStrLn ("Hello again! - " ++ str ++ " was pressed")

delete :: IO Bool
delete  = do
	    mainQuit
	    return False	-- `False' means, window may be removed

main :: IO ()
main  = do
	  Gtk.init Nothing

	  window <- windowNew WindowToplevel
	  windowSetTitle window "Hello Buttons!"
	  signalConnect window $ WidgetDeleteEventHandler (\_ _ -> delete)
	  containerBorderWidth window 10

	  -- box for assembling buttons
	  --
	  box <- hBoxNew False 10
	  containerAdd window box

	  button1 <- buttonNewWithLabel "Button 1"
	  let handler1 = const (hello "button 1")
	  signalConnect button1 (ButtonClickedHandler handler1)
	  boxPackStart box button1 True True 0
	  widgetShow button1

	  button2 <- buttonNewWithLabel "Button 2"
	  let handler1 = const (hello "button 2")
	  signalConnect button2 (ButtonClickedHandler handler1)
	  boxPackStart box button2 True True 0
	  widgetShow button2

	  buttonQuit <- buttonNewWithLabel "Quit"
	  let quitHandler = widgetDestroy window >> mainQuit
	  signalConnect buttonQuit (ButtonClickedHandler $ const quitHandler)
	  boxPackStart box buttonQuit True True 0
	  widgetShow buttonQuit

	  widgetShow box
	  widgetShow window

	  Gtk.main
	  exitWith ExitSuccess
