-- test idle and timeout handlers

import System     (getArgs, ExitCode(ExitSuccess, ExitFailure), exitWith)

import IOExts

import Gtk        hiding (init, main)
import qualified
       Gtk        (init, main)

-- idle handler 
--
idleHandler         :: Label -> IORef Int ->  IO Bool
idleHandler lbl var  = do
		         num <- readIORef var
			 writeIORef var (num + 1)
			 labelSet lbl ("Label #" ++ show num)
			 return True

-- show the current number when a timeout occurs
--
timeout     :: IORef Int -> IO Bool
timeout var  = do
                 num <- readIORef var
                 putStrLn ("The current number is " ++ show num)
                 return True

main :: IO ()
main  = do
	  Gtk.init Nothing

	  window <- windowNew WindowToplevel
	  windowSetTitle window "GTK+ Idle & Timeout Test"
	  windowSetDefaultSize window 180 90
	  let winDelHdl = WidgetDeleteEventHandler $ \_ _ -> do
							       mainQuit
							       return False
	  signalConnect window winDelHdl
	  containerBorderWidth window 10

	  label <- labelNew "Initial label"
	  containerAdd window label

          var <- newIORef (0 :: Int)
          idleAdd (IdleHandler $ idleHandler label var)
          timeoutAdd 500 (TimeoutHandler $ timeout var)

	  widgetShowAll window
	  Gtk.main
	  exitWith ExitSuccess
