-- test label and frame widgets

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk     hiding (init, main)
import qualified
       Gtk    (init, main)

delete :: IO Bool
delete  = do
	    mainQuit
	    return False

main :: IO ()
main  = do
	  Gtk.init Nothing

	  window <- windowNew WindowToplevel
	  windowSetTitle window "Label & Frame"
	  signalConnect window 
				 (WidgetDeleteEventHandler (\_ _ -> delete))
	  containerBorderWidth window 10

	  frame <- frameNew "Frame Label"
	  frameSetShadowType frame ShadowEtchedOut
	  containerAdd window frame

	  label <- labelNew "This is the text of a label that is set \
			    \line-wrapped and filled, and thus, it can \
			    \nicely display a lot of text.\n\
			    \     It is so smart that it even knows about \
			    \paragraphs and proves that GTK+ is a very \
			    \cool toolkit, indeed."
          labelSetLineWrap label True
	  labelSetJustify label JustifyFill
	  containerAdd frame label

	  widgetShowAll window

	  Gtk.main
	  exitWith ExitSuccess
