-- call as
--   % modtest modtest_one
--   % modtest modtest_two

module Main where

import Monad (when, unless, liftM)
import Maybe (fromJust, isNothing)
import System

import Foreign

import GModule


foreign import dynamic unsafe ctest__ 
  :: FunPtr (Int -> IO ()) -> (Int -> IO ())


main = do
    argv   <- getArgs
    symbol <- case argv of
      [sym] -> return sym
      _     -> do
           putStrLn "usage: modtest symname"
	   exitWith (ExitFailure 1)

    withModule (Just ".") "modtest" ModuleBindOnLoad $ \ mod -> do
    
        putStrLn $ "loading from " ++ moduleName mod
    
        ctestPtr <- moduleSymbol mod symbol
        if isNothing ctestPtr
          then do
            putStrLn =<< moduleError
	    exitWith (ExitFailure 2)
          else do
            let cTest = ctest__ (castPtrToFunPtr (fromJust ctestPtr))
            cTest 42
    
    return ()
