-- program to test the table widget (adapted from GTK+/Gnome book)
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gtk    hiding (main, init)
import qualified
       Gtk    (init, main)

main :: IO ()
main  = do
	  Gtk.init Nothing

	  window <- windowNew WindowToplevel
	  windowSetTitle window "Test Table..."
	  signalConnect 
	    window (WidgetDeleteEventHandler (\_ _ -> do 
							mainQuit
							return False))

	  -- create table container
	  --
	  table <- tableNew 2 2 False
	  containerAdd window table
	  containerSetBorderWidth table 10

	  -- the following is to experiment with resizing, but usually a bad
	  -- idea in real code
	  --
	  windowSetPolicy window True True True

	  button <- buttonNewWithLabel "1. Doesn't shrink\nor expand"
	  tableAttach table button 0 1 0 1 [Fill] [Fill] 0 0

	  button <- buttonNewWithLabel "2. Expands and shrinks\n\
					  \vertically"
	  tableAttach table button 0 1 1 2 
	    [Fill] [Fill, Expand, Shrink] 0 0

	  button <- buttonNewWithLabel "3. Expands and shrinks\n\
					  \in both directions"
	  tableAttach table button 1 2 0 2 
	    [Fill, Expand, Shrink] [Fill, Expand, Shrink] 0 0

	  widgetShowAll window
	  Gtk.main
	  exitWith ExitSuccess
