-- program to test some tooltips functionality
--

import System (getArgs, ExitCode(ExitSuccess), exitWith)
import Gdk    (ModifierType(..))
import Gtk    (WindowType(..),
               ObjectSignalHandler(..), 
	       Box, boxPackStart,
	       HBox, hBoxNew,
	       VBox, vBoxNew,
	       Button, buttonNewWithLabel,
	       ButtonSignalHandler(..),
	       CheckButton, checkButtonNewWithLabel,
	       Container, containerBorderWidth, containerAdd,
	       ToggleButton, toggleButtonNewWithLabel,
	       toggleButtonSetMode, toggleButtonQueryState,
	       Widget, widgetShow, widgetDestroy,
	       WidgetSignalHandler(..), signalConnect,
	       Window, windowNew, windowSetTitle,
               Tooltips(..), tooltipsNew, tooltipsSetTip,
               tooltipsSetDelay,tooltipsEnable,tooltipsDisable,
               AccelGroup(..), 
               AccelFlags(..),
               accelGroupNew, accelGroupGetDefault,
               accelGroupAdd, accelGroupRemove,
               accelGroupAttach, accelGroupDetach,
               accelGroupRef, accelGroupUnref,
               accelGroupsActivate,
               accelGroupLock, accelGroupUnlock,
               acceleratorValid,
               acceleratorName,
               widgetAddAccelerator,
	       mainQuit)
import qualified
       Gtk    (init, main)

delete :: ToggleButton -> CheckButton -> IO ()
delete togBtn checkBtn = 
  do
    active <- toggleButtonQueryState togBtn
    putStr ("Toggle button: " ++ (if active then "on" else "off") ++ "\n")
    checked <- toggleButtonQueryState checkBtn
    putStr ("Check button: " ++ (if checked then "on" else "off") ++ "\n")
    mainQuit

main :: IO ()
main  = do
	  Gtk.init Nothing


	  window <- windowNew WindowToplevel
	  windowSetTitle window "Tooltips & Buttons..."
	  containerBorderWidth window 10

          ttip <- tooltipsNew

	  -- box for the whole thing
	  --
	  bigBox <- vBoxNew False 10
	  containerAdd window bigBox

	  checkBtn <- checkButtonNewWithLabel " Check me out! "
	  containerAdd bigBox checkBtn
	  widgetShow checkBtn
          
          signalConnect checkBtn $ ButtonClickedHandler
           (\_ -> do 
                   tooltipsSetDelay ttip 5000
                   tooltipsEnable ttip)

	  -- box for assembling buttons
	  --
	  butBox <- hBoxNew False 10
	  containerAdd bigBox butBox

	  togBtn <- toggleButtonNewWithLabel " On/Off "
	  boxPackStart butBox togBtn True True 0
--	  toggleButtonSetMode togBtn True
	  widgetShow togBtn
          signalConnect togBtn $ ButtonClickedHandler
           (\_ -> tooltipsDisable ttip)

          tooltipsSetTip ttip togBtn "Cool button" 
                "This cool button is extremely useful, oh the things it can do"

	  buttonQuit <- buttonNewWithLabel " Quit "
	  let quitHandler wd = delete togBtn checkBtn
	  signalConnect buttonQuit (ButtonClickedHandler quitHandler)
	  boxPackStart butBox buttonQuit True True 0
	  widgetShow buttonQuit

          agroup <- accelGroupGetDefault
          accname <- acceleratorName 'a' [Mod1Mask]
          putStr $ "Accelerator name: " ++ accname ++ "\n"
          widgetAddAccelerator buttonQuit "clicked" agroup
                               'a' [Mod1Mask] AccelNone

	  -- can't be near the alloc of `window', because we need the buttons
	  --
	  signalConnect 
	    window (WidgetDeleteEventHandler (\_ _ -> do
							delete togBtn checkBtn
							return False))
	  widgetShow butBox
	  widgetShow bigBox
	  widgetShow window

	  Gtk.main

	  exitWith ExitSuccess
